package java.util.function;

import java.util.Objects;

@FunctionalInterface
public interface Function<T, R>
{
    public abstract R apply(T p0);
    
    default public <V> Function<V, R> compose(Function<? super V, ? extends T> obj) {
        Objects.requireNonNull(obj);
        return o/* java.lang.Object, */ -> this.apply(p0.apply(o));
    }
    
    default public <V> Function<T, V> andThen(Function<? super R, ? extends V> obj) {
        Objects.requireNonNull(obj);
        return o/* java.lang.Object, */ -> p0.apply(this.apply(o));
    }
    
    public static <T> Function<T, T> identity() {
        return o/* java.lang.Object, */ -> o;
    }
}
